/*====================================================================================================
 *    DEFINITION DES LABELS ET ADRESSES PERMETTANT L'ACCES AUX REGISTRES DU MICROPROCESSEUR 68332
 * ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 * 	Nom du fichier:        CPU_REG.H						   						  
 * 	Date de cration :         Aout 2001
 * 	Date de la dernire rvision :  Fvrier 2003 			 		                               
 * 	Auteurs:    J.L.  ROHOU         T. HANS  			                       
 *======================================================================================================*/
#ifndef _CPU_H
#define _CPU_H
/**************************************
 *              Pour le  SIM 
 *    " System Integration Module "            
/**************************************/
 		#define VBR 	*(WORD*)	0x000000		/* Vector Base Register Vecteur de base 5-6*/
		/* registre de configuration du system integration module */
		#define Simcr	*(WORD*)	0xFFFA00		/* regitre de controle de la configuration du SIM */
		#define Syncr	*(WORD*)	0xFFFA04		/* registre de controle de l'horloge p */
		#define Sypcr	*(WORD*)	0xFFFA21		/* registre de controle du systeme de protection */
		#define Picr	*(WORD*)	0xFFFA22		/* registre de controle des interruptions */
		#define Pitr	*(WORD*)	0xFFFA24		/* registre de controle du timer d'interruption */
		#define Rsr		*(WORD*)	0xFFFA07		/* reset register */
		/* registre de configuration des chip selects */
		#define	Cspar0	*(WORD*)	0xFFFA44		/* reg. de contr. de la config du CSboot et des chip selects CS0  CS5 */
		#define	Cspar1	*(WORD*)	0xFFFA46		/* regitre de controle de la configuration des chips selects CS6  CS10 */
		#define	Csbarbt *(WORD*)	0xFFFA48		/* regitre de configuration de l'adresse de base du chip select BOOT */
		#define	Csorbt	*(WORD*)	0xFFFA4A		/* regitre de controle des options de configuration du chip select BOOT */
		#define	Csbar0	*(WORD*)	0xFFFA4C		/* regitre de configuration de l'adresse de base du chip select CS0 */
		#define	Csor0	*(WORD*)	0xFFFA4E		/* regitre de controle des options de configuration du chip select CS0 */
		#define	Csbar1	*(WORD*)	0xFFFA50		/* regitre de configuration de l'adresse de base du chip select CS1 */
		#define	Csor1	*(WORD*)	0xFFFA52		/* regitre de controle des options de configuration du chip select CS1 */
		#define	Csbar2	*(WORD*)	0xFFFA54		/* regitre de configuration de l'adresse de base du chip select CS2 */
		#define	Csor2	*(WORD*)	0xFFFA56		/* regitre de controle des options de configuration du chip select CS2 */
		#define	Csbar3	*(WORD*)	0xFFFA58		/* regitre de configuration de l'adresse de base du chip select CS3 */
		#define	Csor3	*(WORD*)	0xFFFA5A		/* regitre de controle des options de configuration du chip select CS3 */
		#define	Csbar4	*(WORD*)	0xFFFA5C		/* regitre de configuration de l'adresse de base du chip select CS4 */
		#define	Csor4	*(WORD*)	0xFFFA5E		/* regitre de controle des options de configuration du chip select CS4 */
		#define	Csbar5	*(WORD*)	0xFFFA60		/* regitre de configuration de l'adresse de base du chip select CS5 */
		#define	Csor5	*(WORD*)	0xFFFA62		/* regitre de controle des options de configuration du chip select CS5 */
		#define	Csbar6	*(WORD*)	0xFFFA64		/* regitre de configuration de l'adresse de base du chip select CS6 */
		#define	Csor6	*(WORD*)	0xFFFA66		/* regitre de controle des options de configuration du chip select CS6 */
		#define	Csbar7	*(WORD*)	0xFFFA68		/* regitre de configuration de l'adresse de base du chip select CS7 */
		#define	Csor7	*(WORD*)	0xFFFA6A		/* regitre de controle des options de configuration du chip select CS7 */
		#define	Csbar8	*(WORD*)	0xFFFA6C		/* regitre de configuration de l'adresse de base du chip select CS8 */
		#define	Csor8	*(WORD*)	0xFFFA6E		/* regitre de controle des options de configuration du chip select CS8 */
		#define	Csbar9	*(WORD*)	0xFFFA70		/* regitre de configuration de l'adresse de base du chip select CS9 */
		#define	Csor9	*(WORD*)	0xFFFA72		/* regitre de controle des options de configuration du chip select CS9 */
		#define	Csbar10 *(WORD*)	0xFFFA74		/* regitre de configuration de l'adresse de base du chip select CS10 */
		#define	Csor10	*(WORD*)	0xFFFA76		/* regitre de controle des options de configuration du chip select CS10 */
 
/********************************
 *          Pour le  TPU
 *  " Time Processor Unit "
/********************************/

#define TPUMCR	*(short *)(0xFFFE00)	// Module Configuration Register  -> Pour configurer le registre

#define CFSR0	*(short *)(0xFFFE0C)	// Channel Function Select Register
#define CFSR1	*(short *)(0xFFFE0E)	// Permet de dfinir la fonction souhaite pour chacun des
#define CFSR2	*(short *)(0xFFFE10)	// 15 canaux (lignes) d'entre-sortie (TPU0  TPU15)
#define CFSR3	*(short *)(0xFFFE12)	// 4 bits sont affects  un mme canal

#define HSQR0	*(short *)(0xFFFE14)	// Host Sequence Queu Register
#define HSQR1	*(short *)(0xFFFE16)	// Permet d'effectuer un chantillonnage des canaux configurs en entre

#define HSRR0 	*(short *)(0xFFFE18)	// Host Sequence Request Register
#define HSRR1	*(short *)(0xFFFE1A) 	// Permet l'accs aux canaux d'entre-sortie

#define CPR0		*(short *)(0xFFFE1C)	// Chanel Priority Register
#define CPR1		*(short *)(0xFFFE1E)	// Permet de dfinir les niveaux de priorit 

#define CTRL_TPU0	*(short *)(0xFFFF00)	// ConTRoL
#define CTRL_TPU1	*(short *)(0xFFFF10)	// Une zone de 8 mots d'tat est rserve  chaque canal d'entre sortie
#define CTRL_TPU2	*(short *)(0xFFFF20)
#define CTRL_TPU3	*(short *)(0xFFFF30)
#define CTRL_TPU4	*(short *)(0xFFFF40)
#define CTRL_TPU5	*(short *)(0xFFFF50)
#define CTRL_TPU6	*(short *)(0xFFFF60)
#define CTRL_TPU7	*(short *)(0xFFFF70)
#define CTRL_TPU8	*(short *)(0xFFFF80)
#define CTRL_TPU9	*(short *)(0xFFFF90)
#define CTRL_TPU10	*(short *)(0xFFFFA0)
#define CTRL_TPU11	*(short *)(0xFFFFB0)
#define CTRL_TPU12	*(short *)(0xFFFFC0)
#define CTRL_TPU13	*(short *)(0xFFFFD0)
#define CTRL_TPU14	*(short *)(0xFFFFE0)
#define CTRL_TPU15	*(short *)(0xFFFFF0)

// Pour le temporisateur programmable
#define PITR	*(short *)(0xFFFA24)	//
#define PICR	*(short *)(0xFFFA22)


/**************************************
 *         Pour  le QSM
 *    "Queued Serial Module"        
 **************************************/

#define QSMCR  	*(WORD*)		0xFFFC00
#define QILR  		*(WORD*)		0xFFFC04	// Pour la priorit et vecteur interruption en liaison srie
#define SCCR0  	*(WORD*)		0xFFFC08
#define SCCR1  	*(WORD*)		0xFFFC0A
#define SCSR   	*(WORD*)		0xFFFC0C
#define SCDR   	*(WORD*)		0xFFFC0E				

#define PORTQS *(WORD*)		0xFFFC14
#define PQSCTR *(WORD*)		0xFFFC16   /* PQSPAR-DDRQS */

#define SPCR0  *(WORD*) 	0xFFFC18
#define SPCR1  *(WORD*)		0xFFFC1A
#define SPCR2  *(WORD*)		0xFFFC1C
#define SPCR3  *(BYTE*)		0xFFFC1E
#define SPSR   *(BYTE*)		0xFFFC1F
#define SPI_RXD (WORD*)		0xFFFD00
#define SPI_TXD (WORD*)		0xFFFD20
#define SPI_CMD (BYTE*)		0xFFFD40

#define TDRE   (WORD)	0x0100
#define RDRF   (WORD)	0x0040
#define RAF	   (WORD)	0x0020
		

#endif
