//===================================================================
// 	DECLARATIONS DES ADRESSES DES ELEMENTS DE LA CARTE EID210
//--------------------------------------------------------------------------------------------------------------------------------------
// 	Nom du fichier:        EID210_reg.h						          
// 	Date de cration:          Aout 2001			 
// 	Date de dernire modification: Janv 2003
 // 	Auteurs:        T. HANS  J.L. ROHOU                                      
 //======================================================================

#ifndef _EID210_H
#define _EID210_H

/*           Version materielle et logicielle        */
/*==================================*/
#define VERSION_HARD	0x00	/* Version et revision du hard */
#define REVISION_HARD	0x00
#define VERSION_SOFT	0x00	/* Version et revision du programme */
#define	REVISION_SOFT	0x00


 /* Adresses de bases des priphriques */
 #define	CTRL	   			  		0x900000 		/* 	CPLD de controle  sur     CS2  	*/
 #define	REG_ETAT 	(*(union word_bits_octet*)		(CTRL+0x00)) 		/* registre d'tat (en lecture uniquement)	*/			
 #define	REG_CTRL 	(*(union word_bits_octet*)		(CTRL+0x02))		/* registre de controle (en lecture et r.	*/			 
 #define  	A_Port_C	(*(struct word_bytes*)		(CTRL+0x100)) 	/*  Accs au registre de donne du Port C	*/
 #define    	A_Dir_Port_C	(*(struct word_bytes*)		(CTRL+0x102)) 	/* Accs au registre de direction du port C 	*/                    
 #define	USB			 		  	0xB00000		/*  Ad. de base Port USB             CS3  	*/	   
 #define	CNA			 		  	0xB10000		/*  Ad. de base du Conv. Num -> Ana  CS4 	*/	   	
 #define	SA0		(*(BYTE*)	  		(CNA+0x00))		/*  	Sortie Analogique voie 0  (SA0) 	*/
 #define	SA1		(*(BYTE*)	    		(CNA+0x01))		/*  	Sortie Analogique voie 0  (SA0) 	*/
 #define	SA2		(*(BYTE*)	 	   	(CNA+0x02))		/*  	Sortie Analogique voie 0  (SA0) 	*/
 #define	SA3		(*(BYTE*)	 	   	(CNA+0x03))		/*  	Sortie Analogique voie 0  (SA0) 	*/
 #define	CAN		(*(WORD*)	 	   	0xB20000)		/*  Convertisseur Ana -> Num    sur  CS5  	*/
 #define	BUS			 		  	0xB30000		/*  Ad. de base du Conv. Num -> Ana  CS7 	*/		   
 
 /* Pour accder au diffrentes information du registre d'tat */
 /* Bits accessibles en lecture uniquement */
 #define Etat_reset		REG_ETAT.bits_octet.b15	/* RESERVE	 (Prog ne toune pas si RESET!	*/
 #define E_Irq_CAN		REG_ETAT.bits_octet.b14	/* Etat du Bit de fin de conversion Ana -> Num 	*/
 #define E_Irq_USB		REG_ETAT.bits_octet.b13	/* Etat du Bit d'tat de la ligne d'interruption USB	*/
 #define E_Irq4_Bus		REG_ETAT.bits_octet.b12	/* Etat du Bit d'tat ligne IRQ4 du BUS		*/
 #define E_Irq3_Bus		REG_ETAT.bits_octet.b11	/* Etat du Bit d'tat ligne IRQ3 du BUS		*/
 #define E_Irq2_Bus		REG_ETAT.bits_octet.b10	/* Etat du Bit d'tat ligne IRQ2 du BUS		*/
 #define E_Irq1_Bus		REG_ETAT.bits_octet.b9	/* Etat du Bit d'tat ligne IRQ1 du BUS		*/
 #define S_Controle		REG_ETAT.bits_octet.b8	/* Etat du Etat du "Switch de Contrle			*/
 #define N_VERSION		REG_ETAT.bits_octet.O_lsb	/*   N de VERSION soft PLD sur 8 bits		*/
#define B_Num_Version_EID210 N_VERSION

/*  Pour autoriser (valider) les interruptions   */
#define VALID_IRQs	(*(union word_octet_bits*) (0x900004))
#define Valid_IrqCtrl		VALID_IRQs.octet_bits.b1
#define Valid_IrqCan		VALID_IRQs.octet_bits.b2
#define Valid_Irq1		VALID_IRQs.octet_bits.b3
#define Valid_Irq2		VALID_IRQs.octet_bits.b4
#define Valid_Irq3		VALID_IRQs.octet_bits.b5
#define Valid_Irq4		VALID_IRQs.octet_bits.b6
#define Valid_IrqUsb		VALID_IRQs.octet_bits.b7
#define Valid_unused		VALID_IRQs.octet_bits.b0

/* pour liberer les irq4 et ctrl */

#define RAZ_IRQ_PORT	REG_CTRL.bits_octet.b12
#define RAZ_IRQ_CTRL	REG_CTRL.bits_octet.b8

// Pour une gestion directe du port C
#define Port_C 	A_Port_C.O_msb.valeur
#define PortC	Port_C
#define Dir_Port_C 	A_Dir_Port_C.O_msb.valeur
#define DirPortC Dir_Port_C
#define Dir_PortC Dir_Port_C
#define PortCDir Dir_Port_C
#define PortC_Dir Dir_Port_C
#define PC0	A_Port_C.O_msb.bit.b0
#define PC1	A_Port_C.O_msb.bit.b1
#define PC2	A_Port_C.O_msb.bit.b2
#define PC3	A_Port_C.O_msb.bit.b3
#define PC4	A_Port_C.O_msb.bit.b4
#define PC5	A_Port_C.O_msb.bit.b5
#define PC6	A_Port_C.O_msb.bit.b6
#define PC7	A_Port_C.O_msb.bit.b7

// Pour la gestion du convertisseur A->N
#define Fin_Conv_AN E_Irq_CAN

#endif