//=======================================================================
//	STRUCTURES DE DONNEES UTILES A LA PROGRAMMATION EN  C
//=======================================================================
// 	Nom du fichier:        Structures_donnees.h						          
// 	Date de cration:          Aout 2001			 
// 	Date de dernire modification:  Mai 2003
// 	Auteurs:        T. HANS  J.L. ROHOU                                      
//========================================================================

/* Redfinition des types */
		typedef unsigned char	BYTE;
		typedef unsigned short  WORD;
		typedef unsigned long	ULONG;

/* 	Union pour accder  un octet (BYTE) soit en direct, soit en individualisant les 8 bits 
//******************************************************************************************************/
	union byte_bits
	{	struct 
		 {
			unsigned char b7:1;
			unsigned char b6:1;
			unsigned char b5:1;
			unsigned char b4:1;
			unsigned char b3:1;
			unsigned char b2:1;
			unsigned char b1:1;
			unsigned char b0:1;
		}bit;
		BYTE valeur;
	};

/* 	Union pour accder  un mot de 16 bit  soit en direct soit en individualisant les 16 bits 
//*****************************************************************************************************/
	union word_bits
	{	struct
		{
			unsigned char b15:1;
			unsigned char b14:1;
			unsigned char b13:1;
			unsigned char b12:1;
			unsigned char b11:1;
			unsigned char b10:1;
			unsigned char b9:1;
			unsigned char b8:1;
			unsigned char b7:1;
			unsigned char b6:1;
			unsigned char b5:1;
			unsigned char b4:1;
			unsigned char b3:1;
			unsigned char b2:1;
			unsigned char b1:1;
			unsigned char b0:1;
		} bit;
		WORD valeur;
	};

/* 	Union pour accder  un mot de 16 bit  soit en direct 
	  soit en sparant les 16 bits par ensembles de 2 bits  (Utile pour les sorties TPU)
//*****************************************************************************************************/
	union word_duos
	{	struct
		{
			unsigned char duo7:2;
			unsigned char duo6:2;
			unsigned char duo5:2;
			unsigned char duo4:2;
			unsigned char duo3:2;
			unsigned char duo2:2;
			unsigned char duo1:2;
			unsigned char duo0:2;
			
		} duo;
		WORD valeur;
	};

/*   Structure pour accder  un mot de 16 bits soit en direct soit en sparant sur 8 bits de poids forts (b15  b8) 
     et gardant unis les 8 bits de poids faibles (O_lsb)
 **************************************************************************************************************************/
	union word_bits_octet
	{	struct
		{
			unsigned char b15:1;
			unsigned char b14:1;
			unsigned char b13:1;
			unsigned char b12:1;
			unsigned char b11:1;
			unsigned char b10:1;
			unsigned char b9:1;
			unsigned char b8:1;
			unsigned char O_lsb:8;
		} bits_octet;
		WORD val_wbo;
	};

/*   Structure pour sparer l'octet de poids forts (O_msb) de l'octet de poids faibles (O_lsb) 
     d'un mot de 16 bits, avec l'octet de poids fort pouvant tre spar en 8 bits individuels
 *********************************************************************************************************/
struct word_bytes
	{ union byte_bits O_msb;
	  unsigned char O_lsb;
	 };

/*   Union pour accder  un mot de 16 bits (WORD) soit en direct soit en sparant sur 8 bits de poids faibles (b0  b7) 
    et gardant unis les 8 bits de poids forts (O_msb)
 ********************************************************************************************************************************/
union word_octet_bits
	{	struct
		{
			unsigned char O_msb:8;
			unsigned char b7:1;
			unsigned char b6:1;
			unsigned char b5:1;
			unsigned char b4:1;
			unsigned char b3:1;
			unsigned char b2:1;
			unsigned char b1:1;
			unsigned char b0:1;
		} octet_bits;
		WORD valeur;
	};

// Union pour partager un entier (Intger -> 32Bits) en deux Word ->  2X16Bits

union U_Entier_2X16b
	{struct
		{short S_MSB :16;
		 short S_LSB : 16;
		}St_2X16b;
	int I_32b;
	};


//  Fin de fichier