/***************************************************************************
 * Module:        TPU.H						                               * 
 * Date:         Aout 2001		 		                                   *
 * Auteurs:       T. HANS  J.L. ROHOU                                      *
  * Description:   Declaration des registres pour le TPU du 68332          *
 ***************************************************************************/
#ifndef _TPU_H
#define _TPU_H
#define TRAMMCR	*(WORD*)	0xFFFB00		/* regitre de configuration du module TPURAM */
#define TRAMTST	*(WORD*)	0xFFFA04		/* registre de test TPURAM */
#define TRAMBAR	*(WORD*)	0xFFFA20		/* registre de Status et Adresse de Base */
#define TPUMCR	*(WORD*)	0xFFFE00		/*  TPU module configuration regiter 		*/
#define TCR		*(WORD*)	0xFFFE02		/*  test configuration register             */	  
#define DSCR	*(WORD*)	0xFFFE04		/*  development support control register 	*/
#define DSSR	*(WORD*)	0xFFFE06		/*  development support status register  	*/
#define TICR	*(WORD*)	0xFFFE08		/*  TPU interrupt configuration register 	*/
#define CIER	*(WORD*)	0xFFFE0A		/*  channel interrupt enable register 		*/
#define CFSR0	*(WORD*)	0xFFFE0C		/*  channel function selection register 0 	*/
#define CFSR1	*(WORD*)	0xFFFE0E		/*  channel function selection register 1 	*/
#define CFSR2	*(WORD*)	0xFFFE10		/*  channel function selection register 2 	*/
#define CFSR3	*(WORD*)	0xFFFE12		/*  channel function selection register 3 	*/
#define HSQR0	*(WORD*)	0xFFFE14		/*  host sequence register 0 				*/
#define HSQR1	*(WORD*)	0xFFFE16		/*  host sequence register 1 				*/
#define HSRR0	*(WORD*)	0xFFFE18		/*  host service request 0 					*/
#define HSRR1	*(WORD*)	0xFFFE1A		/*  host service request 1 					*/
#define CPR0	*(WORD*)	0xFFFE1C		/*  channel priority register 0				*/
#define CPR1	*(WORD*)	0xFFFE1E		/*  channel priority register 1 		 	*/
#define CISR	*(WORD*)	0xFFFE20		/*  channel interrupt status register 		*/
#define LR		*(WORD*)	0xFFFE22		/*  link register 							*/
#define SGLR	*(WORD*)	0xFFFE24		/*  service grant latch register 			*/
#define DCNR	*(WORD*)	0xFFFE26		/*  decoded channel number register 	 	*/
#define CTRL_TPU0 *(WORD*) 	0xFFFF00	    /* Adresse de Base pour la canal TPU0       */
#define CTRL_TPU1 *(WORD*) 	0xFFFF10		/* qui est celle du registre de contrle  	*/ 
#define CTRL_TPU2 *(WORD*) 	0xFFFF20
#define CTRL_TPU3 *(WORD*) 	0xFFFF30
#define CTRL_TPU4 *(WORD*) 	0xFFFF40
#define CTRL_TPU5 *(WORD*) 	0xFFFF50
#define CTRL_TPU6 *(WORD*) 	0xFFFF60
#define CTRL_TPU7 *(WORD*) 	0xFFFF70
#define CTRL_TPU8 *(WORD*) 	0xFFFF80
#define CTRL_TPU9 *(WORD*) 	0xFFFF90
#define CTRL_TPU10 *(WORD*)	0xFFFFA0
#define CTRL_TPU11 *(WORD*)	0xFFFFB0
#define CTRL_TPU12 *(WORD*)	0xFFFFC0
#define CTRL_TPU13 *(WORD*)	0xFFFFD0
#define CTRL_TPU14 *(WORD*)	0xFFFFE0
#define CTRL_TPU15 *(WORD*)	0xFFFFF0	    /* Adresse de Base pour le canal TPU15     */
#endif