#ifndef __EID210_H
#define __EID210_H

/* Structure sur 8 bits + octet*/
	union word_bits_octet
	{
		struct
		{
			unsigned char b15:1;
			unsigned char b14:1;
			unsigned char b13:1;
			unsigned char b12:1;
			unsigned char b11:1;
			unsigned char b10:1;
			unsigned char b9:1;
			unsigned char b8:1;
			unsigned char b_octet:8;
		} bits_octet;
		unsigned short val_wbo;
	};

#define	CTRL	   			  			0x900000 		/* 	CPLD de contrle       sur       CS2  	*/
#define	REG_ETAT (*(union word_bits_octet*)	(CTRL+0x00))

#define 	REG_CTRL (*(union word_bits_octet*)	(CTRL+0x02))

#define         VAL_IRQ_CTRL 	REG_CTRL.bits_octet.b8
#define         VAL_IRQ_PORT	REG_CTRL.bits_octet.b12

#define Etat_reset		REG_ETAT.bits_octet.b15	/* RESERVE	 (Prog ne toune pas si RESET!		*/
#define IRQ_CAN		REG_ETAT.bits_octet.b14	/* Bit de fin de conversion Ana -> Num 			*/
#define IRQ_USB		REG_ETAT.bits_octet.b13	/* Bit d'tat de la ligne d'interruption USB	*/
#define BUS_IRQ4		REG_ETAT.bits_octet.b12	/* Bit d'tat ligne IRQ4 du BUS					*/
#define BUS_IRQ3		REG_ETAT.bits_octet.b11	/* Bit d'tat ligne IRQ3 du BUS					*/
#define BUS_IRQ2		REG_ETAT.bits_octet.b10	/* Bit d'tat ligne IRQ2 du BUS					*/
#define BUS_IRQ1		REG_ETAT.bits_octet.b9	/* Bit d'tat ligne IRQ1 du BUS					*/
#define CRTL			REG_ETAT.bits_octet.b8	/* Etat du "Switch de Contrle					*/
#define N_VERSION		REG_ETAT.bits_octet.b_octet	/* N de VERSION soft PLD sur 8 bits		*/

union bits_octet
{
	struct
	{
		unsigned char b7:1;
		unsigned char b6:1;
		unsigned char b5:1;
		unsigned char b4:1;
		unsigned char b3:1;
		unsigned char b2:1;
		unsigned char b1:1;
		unsigned char b0:1;
	} bit;
	unsigned char octet;
	unsigned short word;
};


struct PortC
{
union bits_octet valeur;
union bits_octet direction;
};


#define port_c	(*(struct PortC *) 0x900100)
#define PortCDir	port_c.direction.octet
#define PortCPort	port_c.valeur.octet

#define PC0		port_c.valeur.bit.b0	  	/* Bit 0 du port C 		*/
#define PC1		port_c.valeur.bit.b1	 	/* Bit 1 du port C 		*/
#define PC2		port_c.valeur.bit.b2		/* Bit 2 du port C 		*/
#define PC3		port_c.valeur.bit.b3		/* Bit 3 du port C 		*/
#define PC4		port_c.valeur.bit.b4		/* Bit 4 du port C 		*/
#define PC5		port_c.valeur.bit.b5		/* Bit 5 du port C 		*/
#define PC6		port_c.valeur.bit.b6		/* Bit 6 du port C 		*/
#define PC7		port_c.valeur.bit.b7		/* Bit 7 du port C 		*/

#define AFF_0	0xC0
#define AFF_1	0xF9
#define AFF_2	0xA4
#define AFF_3	0xB0
#define AFF_4	0x99
#define AFF_5	0x92
#define AFF_6	0x82
#define AFF_7	0xF8
#define AFF_8	0x80
#define AFF_9	0x90
#define AFF_10	0x88
#define AFF_11	0x83
#define AFF_12	0xC6
#define AFF_13	0xA1
#define AFF_14	0x86
#define AFF_15	0x8E

#define CFSR0	*(short *)(0xFFFE0C)
#define CFSR1	*(short *)(0xFFFE0E)
#define CFSR2	*(short *)	(0xFFFE10)
#define CFSR3	*(short *)(0xFFFE12)

#define HSQR0		*(short *)(0xFFFE14)
#define HSQR1		*(short *)(0xFFFE16)

#define HSRR0	 	*(short *)(0xFFFE18)
#define HSRR1		*(short *)(0xFFFE1A)

#define CPR0		*(short *)(0xFFFE1C)
#define CPR1		*(short *)(0xFFFE1E)

#define CTRL_TPU0	*(short *)(0xFFFF00)
#define CTRL_TPU1	*(short *)(0xFFFF10)
#define CTRL_TPU2	*(short *)(0xFFFF20)
#define CTRL_TPU3	*(short *)(0xFFFF30)
#define CTRL_TPU4	*(short *)(0xFFFF40)
#define CTRL_TPU5	*(short *)(0xFFFF50)
#define CTRL_TPU6	*(short *)(0xFFFF60)
#define CTRL_TPU7	*(short *)(0xFFFF70)
#define CTRL_TPU8	*(short *)(0xFFFF80)
#define CTRL_TPU9	*(short *)(0xFFFF90)
#define CTRL_TPU10	*(short *)(0xFFFFA0)
#define CTRL_TPU11	*(short *)(0xFFFFB0)
#define CTRL_TPU12	*(short *)(0xFFFFC0)
#define CTRL_TPU13	*(short *)(0xFFFFD0)
#define CTRL_TPU14	*(short *)(0xFFFFE0)
#define CTRL_TPU15	*(short *)(0xFFFFF0)

struct f_isr
{
	int	sauv_reg;
	short c_jsr;
	int	adr_jsr;
	int recup_reg;
	short retour;
	int old_vect;
	struct f_isr *p_isr;
};

/* Valide IRQ*/
union valid_irq
	{
		struct
		{
			unsigned char b_octet:8;
			unsigned char usb:1;
			unsigned char irq4:1;
			unsigned char irq3:1;
			unsigned char irq2:1;
			unsigned char irq1:1;
			unsigned char can:1;
			unsigned char ctrl:1;
			unsigned char unused:1;
		} bits_octet;
		unsigned short valeur;
	};

#define VALID_IRQ	(*(union valid_irq*) (0x900004))

#define IrqCtrl		VALID_IRQ.bits_octet.ctrl
#define IrqCan		VALID_IRQ.bits_octet.can
#define Irq1		VALID_IRQ.bits_octet.irq1
#define Irq2		VALID_IRQ.bits_octet.irq2
#define Irq3		VALID_IRQ.bits_octet.irq3
#define Irq4		VALID_IRQ.bits_octet.irq4
#define IrqUsb		VALID_IRQ.bits_octet.usb

/*void InitAff();
void EcritAff(char valeur);*/

#endif