

#include <stdio.h>
#include <time.h>


#include "structures_donnees.h"
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "etd500.h"

#define TAILLE_BUFFER 32

typedef struct
	{
	char buffer[TAILLE_BUFFER];
	int rang_irq;
	int rang;
	int nb_caract;
	} buffer_c;

buffer_c b_recept;
char etat_recept;
buffer_c b_emission;


void EnvoiChaine(const char *c_tx)
{
int i,l;
l=strlen(c_tx);
for(i=0;i<l;i++)
	{
	b_emission.buffer[b_emission.rang]=c_tx[i];
	//gotoxy(1,9);
	printf("(%d)=%2x",b_emission.rang,b_emission.buffer[b_emission.rang]);
	b_emission.rang++;
	b_emission.rang&=(TAILLE_BUFFER-1);
	}
b_emission.buffer[b_emission.rang++]=0;
b_emission.rang&=(TAILLE_BUFFER-1);
b_emission.nb_caract=l+1;
//gotoxy(1,11);
printf(", nb_c=%d, r=%d\n",b_emission.nb_caract,b_emission.rang);
}

int LitSemaphore(char *buffer,int taille)
{
int nb_caract;
int i;
if (etat_recept==1)
	return 0;
nb_caract=b_recept.nb_caract+1;
if (taille<nb_caract)
	nb_caract=taille;
gotoxy(1,30);
printf("etat_rx=%d, nb_c_rx_av=%d, ",etat_recept,b_recept.nb_caract);
for(i=0;i<nb_caract;i++)
	{
	buffer[i]=b_recept.buffer[b_recept.rang];
	printf("(%d)%2x ",b_recept.rang,buffer[i]);
	b_recept.buffer[b_recept.rang++]=0x00;
	b_recept.rang&=(TAILLE_BUFFER-1);
	b_recept.nb_caract--;
	}
if (nb_caract>0)
	{
	b_recept.rang++;
	b_recept.rang&=(TAILLE_BUFFER-1);
	b_recept.nb_caract--;
	}
printf("nb_c_rx_ap=%d\n",b_recept.nb_caract);
buffer[i]=0;
return nb_caract;
}

void irq_rcx()
{
unsigned char rx;
disable();
ETD500_IRQ=0x00;
rx=ETD500_RX;
if (rx!=0&&rx!=255&&rx!=0x55)
	{
	etat_recept=1;
	b_recept.buffer[b_recept.rang_irq++]=(char)(rx&0xFF);
	b_recept.rang_irq&=(TAILLE_BUFFER-1);
	b_recept.nb_caract++;
	}
	else
	{
	if (etat_recept==1)
		{
		b_recept.buffer[b_recept.rang_irq++]=rx;
		b_recept.rang_irq&=(TAILLE_BUFFER-1);
		b_recept.nb_caract++;
		}
	etat_recept=rx;
	}
if (b_emission.nb_caract>0)
	{
	ETD500_TX=b_emission.buffer[b_emission.rang_irq++];
	b_emission.rang_irq&=(TAILLE_BUFFER-1);
	b_emission.nb_caract--;
	}
ETD500_IRQ=0x01;
enable();
}

void init_semaphore()
{
int i;
etat_recept=0;
b_recept.rang_irq=0;
b_recept.rang=0;
b_emission.rang_irq=0;
b_emission.rang=0;
b_recept.nb_caract=0;
b_emission.nb_caract=0;
for(i=0;i<TAILLE_BUFFER;i++)
	{
	b_recept.buffer[i]=0;
	b_emission.buffer[i]=0;
	}
}


main()
{
int nb_essai,nb_erreur;
int i;
unsigned char v;
int tempo;
char travail[22];
char str_test[]="ETD500 DMS-GE test";
clock_t temps,temps1;
init_rcx();		// initialise le RCX
init_semaphore();
init_bt();
SetVect(29,&irq_rcx);
VALID_IRQs.valeur=0x20;
ETD500_IRQ=0x01;
ETD500_GE4=2;	// quipement 4 = vt3
ETD500_GE5=5;	// quipement 5 = vt5
V_CODEC=0x10;	// validation des quipement 4 et 5
//ETD500_TX=0x42;
ETD500_INTER=0xC0;
printf("status_rcx=%x\n",ETD500_status);
E_Mcm(3,17);		// liaison de 3 vers 5
E_Mcm(17,3);		// liaison de 5 vers 3
//printf("compteur=%d reg_etat=%x\n",compteur,E_Irq3_Bus);
nb_essai=0;
nb_erreur=0;
clsscr();
//for(i=0;i<strlen(str_test);i++)
//	printf("%2x ",str_test[i]);
printf("\n");
//EnvoiChaine("!012346789.");
//EnvoiChaine(str_test);
temps=clock();
tempo=0;
while(1)
	{
	temps1=clock();
	if (temps1-temps>500)
		{
		temps=temps1;
		for(i=0;i<TAILLE_BUFFER;i++)
			{
			printf("%2x ",b_recept.buffer[i]&0xFF);
			}
		printf("\nr_irq=%d\n",b_recept.rang_irq);
		sprintf(travail,"%x",tempo&0xFFFF);
		printf("str=%s\n",travail);
		EnvoiChaine(travail);
		tempo++;
		}
	}
/*while(nb_essai<20)
	{
	i=LitSemaphore(travail,21);
	if (i>0)
		{
		if (0!=strcmp(str_test,travail))
			{
			int k;
			gotoxy(1,6);
			nb_erreur++;
			printf("i=%d,n_e=%d er=%d, chaine=%s\n",i,nb_essai,nb_erreur,travail);
			for(k=0;k<i;k++)
				printf("%2x ",travail[k]&0xFF);
			printf("\n");
			sleep(2000);	
			}
			else
			{
			gotoxy(1,3);
			printf("n_e=%d, lec=%s\n",nb_essai,travail);
			sleep(2000);
			}
		nb_essai++;
		while(b_emission.nb_caract>0);
		EnvoiChaine(str_test);	
		}
	}*/
//printf("compteur=%d reg_etat=%x\n",compteur,E_Irq3_Bus);
VALID_IRQs.valeur=0x00;
ETD500_IRQ=0x00;
RestoreVect(29);
stop_bt();
//i=LitSemaphore(travail,18);
//if (i>0)
//	printf("i=%d, chaine=%s\n",i,travail);
printf("nb_c_rx=%d, r_irq=%d, rang=%d\n",b_recept.nb_caract,b_recept.rang_irq,b_recept.rang);
for(i=0;i<TAILLE_BUFFER;i++)
	{
	printf("%2x ",b_recept.buffer[i]&0xFF);
	}
printf("\n");
}