#include "structures_donnees.h"
#include "Cpu_reg.h"
#include "proslic.h"


chipStruct chip[4];

static char *str_etat[]={
"MAKE_BUSY    ",
"STATE_CHANGE ",
"DIALTONE     ",
"INITIALISATIO",
"POWERup      ",
"CALIBRATE    ",
"Program Ring ",
"POWER DOWN   ",
"POWER LEAK   ",
"Make ring Jap",
"make busy jap",
"ring back jap",
"make ring bac",
"ringg back   ",
"makereorder  ",
"reorder      ",
"makeconjestio",
"congestion   ",
"preneon      ",
"NEON         ",
"call back pro",
"busy         ",
"callback     ",
"calling      ",
"makeoffhook  ",
"on hook      ",
"off hook     ",
"digit decodin",
"loop trans   ",
"first ringing",
"deferedcall  ",
"callerid     ",
"ringing      ",
"dtmf          ",
"make connect ",
"connect      "
};

struct  {

	int next;
	ringStruct ringRegs;
}  ringCadenceTables [] [5] =
{
{
	{0, {0x7EF0,0x160,0, 1000*8,2000*8}},//1F40=8000 on,3E80=16000 off
},
{
	{1, {0x7EF0,0x160,0,   200*8,400*8}},//1F40=8000 on,3E80=16000 off
	{0, {0x7EF0,0x160,0,   400*8,1000*8}},//1F40=8000 on,3E80=16000 off
},
{
	{1, {0x7EF0,0x160,0,  400*8,600*8}},
	{0, {0x7EF0,0x160,0,  400*8,1600*8}},
},
{
	{1, {0x7EF0,0x160,0,  600*8,600*8}},
	{0, {0x7EF0,0x160,0,  1200*8,600*8}},		
},
{
	{1, {0x7EF0,0x160,0,  800*8,400*8}},
	{0, {0x7EF0,0x160,0,  200*8,1600*8}},		
},
{
	{0, {0x7EF0,0x160,0,  200*8,300*8}},		
}
};

/****************** COMMON TELEPHONEY TONES*********************************/
tone_struct DialTone = {  /* OSC1= 350 Hz OSC2= 440 Hz .0975 Volts -18 dBm */
	{0x7b30,0x0032,0,0,0,0,0},{0x7870,0x003e,0,0,0,0,0}
};

tone_struct BusySignal = { /* OSC1= 480  OSC2 = 620 .0975 Voltz -18 dBm 8*/
	{0x7700,0x0089,0,0x0f,0xa0,0x0f,0xa0},{0x7120,0x00b2,0,0x0f,0xa0,0x0f,0xa0}
};

tone_struct RingbackNormal = { /* OSC1 = 440 Hz OSC2 = 480 .0975 Volts -18 dBm */
	{0x7870,0x007d,0,0x3e,0x80,0x7d,0x00},{0x7700,0x0089,0,0x3e,0x80,0x7d,0x00}
};

tone_struct ReorderTone = {	/* OSC1= 480 Hz OSC2 = 620 .0975 Volts -18 dBm */
	{0x7700,0x0089,0,0x09,0x60,0x06,0x40},{0x7120,0x00b2,0,0x09,0x60,0x06,0x40}
};
tone_struct CongestionTone = { /* OSC1= 480 Hz OSC2 = 620 .0975 Volts -18 dBM */
	{0x7700,0x0089,0,0x06,0x40,0x09,0x60},{0x7120,0x00b2,0,0x06,0x40,0x09,0x60}
};

/*
The following Array contains:
*/
indirectRegister  indirectRegisters[] =
{
/* Reg#			Label		Initial Value  */

{	0,	"DTMF_ROW_0_PEAK",	0x55C2	},
{	1,	"DTMF_ROW_1_PEAK",	0x51E6	},
{	2,	"DTMF_ROW2_PEAK",	0x4B85	},
{	3,	"DTMF_ROW3_PEAK",	0x4937	},
{	4,	"DTMF_COL1_PEAK",	0x3333	},
{	5,	"DTMF_FWD_TWIST",	0x0202	},
{	6,	"DTMF_RVS_TWIST",	0x0202	},
{	7,	"DTMF_ROW_RATIO",	0x0198	},
{	8,	"DTMF_COL_RATIO",	0x0198	},
{	9,	"DTMF_ROW_2ND_ARM",	0x0611	},
{	10,	"DTMF_COL_2ND_ARM",	0x0202	},
{	11,	"DTMF_PWR_MIN_",	0x00E5	},
{	12,	"DTMF_OT_LIM_TRES",	0x0A1C	},
{	13,	"OSC1_COEF",		0x7b30	},
{	14,	"OSC1X",			0x0063	},
{	15,	"OSC1Y",			0x0000	},
{	16,	"OSC2_COEF",		0x7870	},
{	17,	"OSC2X",			0x007d	},
{	18,	"OSC2Y",			0x0000	},
{	19,	"RING_V_OFF",		0x0000	},
{	20,	"RING_OSC",			0x799A	},
{	21,	"RING_X",			0x019A	},
{	22,	"RING_Y",			0x0000	},
{	23,	"PULSE_ENVEL",		0x2000	},
{	24,	"PULSE_X",			0x2000	},
{	25,	"PULSE_Y",			0x0000	},
{	26,	"RECV_DIGITAL_GAIN",0x4000	},
{	27,	"XMIT_DIGITAL_GAIN",0x4000	},
{	28,	"LOOP_CLOSE_TRES",	0x1000	},
{	29,	"RING_TRIP_TRES",	0x3600	},
{	30,	"COMMON_MIN_TRES",	0x1000	},
{	31,	"COMMON_MAX_TRES",	0x0200	},
{	32,	"PWR_ALARM_Q1Q2",	0x7c0   },
{	33,	"PWR_ALARM_Q3Q4",	0x2600	},
{	34,	"PWR_ALARM_Q5Q6",	0x1B80	},
{	35,	"LOOP_CLSRE_FlTER",	0x8000	},
{	36,	"RING_TRIP_FILTER",	0x06A8	},
{	37,	"TERM_LP_POLE_Q1Q2",0x08c	},
{	38,	"TERM_LP_POLE_Q3Q4",0x0100	},
{	39,	"TERM_LP_POLE_Q5Q6",0x0010	},
{	40,	"CM_BIAS_RINGING",	0x0200	},
{	41,	"DCDC_MIN_V",		0x0C00	},
{	43,	"LOOP_CLOSE_TRES Low",	0x1000	},
{	99,	"FSK 0 FREQ PARAM",	0x00DA	},
{	100,"FSK 0 AMPL PARAM",	0x6B60	},
{	101,"FSK 1 FREQ PARAM",	0x0074	},
{	102,"FSK 1 AMPl PARAM",	0x79C0	},
{	103,"FSK 0to1 SCALER",	0X1120	},
{	104,"FSK 1to0 SCALER",	0x3BE0	},
{	97,	"RCV_FLTR",			0},
{0,"",0},
};

void InitDaisy()
{
BYTE tmp[]={0x0,0xC0};
EcritCmd(2,0);
EcritTx(2,tmp);
Envoi();
}

void EcritDirect(char n,char add,char data)
{
BYTE buffer[3];
buffer[0]=1<<n;
buffer[1]=add&0x7F;
buffer[2]=data;
//printf("Ecr,chip=%d, add=%x, data=%x\n",n,add,data);
EcritCmd(3,0);
EcritTx(3,buffer);
Envoi();
}

BYTE LitDirect(char n,char add)
{
int tempo;
BYTE v;
BYTE buffer[2];
buffer[0]=1<<n;
buffer[1]=0x80+(add&0x7F);
EcritCmd(3,0);
EcritTx(2,buffer);
Envoi();
//affiche_buffer();
for(tempo=0;tempo<100;tempo++);
v=*(SPI_RXD+2);
//printf("LECT, chip=%d, add=%x,data=%x\n",n,add,v);
return v;
}

void WaitForIndirectReg(BYTE n)
{
BYTE status;
do
	{ 
	status=LitDirect(n,I_STATUS);
//	printf("I_status=%x\n",status);
	}
while(status);
}

unsigned short LitIndirectReg(int n,int add)
{
unsigned short v,v1;
WaitForIndirectReg(n);
EcritDirect(n,IAA,add);
WaitForIndirectReg(n);
v1=LitDirect(n,IDA_HI);
v=v1<<8;
v|=LitDirect(n,IDA_LO);
//printf("v1=%x ,v=%x\n",v1,v);
return v;
}

void EcritIndirectReg(int n,int add, unsigned short v)
{
unsigned short v1;
v1=v>>8;
//printf(" e, v1=%x, v=%x\n",v1,v&0xFF);
WaitForIndirectReg(n);
EcritDirect(n,IDA_LO,(BYTE)(v&0xFF));
EcritDirect(n,IDA_HI,(BYTE)(v1&0xFF));
EcritDirect(n,IAA,(BYTE)add);
//WaitForIndirectReg(n);
}

void initializeIndirectRegisters(int n)
{
	unsigned char i=0;
	while (indirectRegisters[i].initial || indirectRegisters[i].address ) {
	EcritIndirectReg(n,indirectRegisters[i].address,indirectRegisters[i].initial);
	i++;
	}
}

void PrintIndirectReg(int n)
{
BYTE i;
printf("chip=%d\n",n);
for(i=0;i<42;i++)
	{
	WORD valeur;
	valeur=LitIndirectReg(n,i);
	printf("%s=%x, v_init=%x\n",indirectRegisters[i].name,valeur,indirectRegisters[i].initial);
	}
}

void setState(int n_chip,int n_stat)
{
chip[n_chip].previousState=chip[n_chip].state;
chip[n_chip].newState= n_stat;
chip[n_chip].state=STATEcHANGE;
//printf("changing stat =%d\n",chip->newState);
switch (n_stat)
	{
			 case CALLERiD:
				 chip[n_chip].eventEnable=0;
				 break;
			 case RINGING:
				 chip[n_chip].eventEnable=1;
				 break;
	}
}

unsigned char PowerUp(int n)
{
BYTE vbat,vbath,vbatl,tmp;
float tension;
EcritDirect(n,74,33);		// vtabh = -48V
EcritDirect(n,75,0x18);		// vbatl = -24V
EcritDirect(n,92,183);
EcritDirect(n,93,21);
tmp=LitDirect(n,94);
printf("94=%x\n",tmp);
EcritDirect(n,14,0);
do
	{
	tmp=LitDirect(n,94);
	vbat=LitDirect(n,82);
	tension=(float)vbat;
	tension*=.376;
	printf("power(%d),vbat=%x=%.2f\n",n,vbat,tension);
	sleep(500);
	}
	while(vbat<0x40);  //0x68
EcritDirect(n,93,0x80);
do
   {
   tmp=LitDirect(n,93);
   printf("reg(93)=%x\n",tmp);
   }
   while(tmp&0x80);
return vbat;
}

unsigned char PowerLeak(int n)
{
BYTE vbat;
EcritDirect(n,64,0);
EcritDirect(n,14,0x10);
sleep(1000);
vbat=LitDirect(n,82);
printf("power down=%x\n",vbat);
return vbat;
}

void calibrate(int n)
{
BYTE cal,result;
printf("calibration\n");
//EcritDirect(n,98,0x10);
//EcritDirect(n,99,0x10);
for(cal=0x1F;cal>0;cal--)
	{
	EcritDirect(n,98,cal);
	sleep(40);
	result=LitDirect(n,88);
	if (result==0)
		break;
	}
printf("98=%x, 88=%x\n",cal,result);
for(cal=0x1F;cal>0;cal--)
	{
	EcritDirect(n,99,cal);
	sleep(40);
	result=LitDirect(n,89);
	if (result==0)
		break;
	}
printf("99=%x, 89=%x\n",cal,result);
}

char * exceptionStrings[] = 
{ " ProSLIC not communicating", "Time out durring Power Up", "Time out durring Power Down","Power is Leaking; might be a short",

" Tip or Ring Ground Short",

"Too Many Q1 Power Alarms" ,"Too Many Q2 Power Alarms" ,"Too Many Q3 Power Alarms" 

"Too Many Q4 Power Alarms" ,"Too Many Q5 Power Alarms" ,"Too Many Q6 Power Alarms" };


void exception (int n,enum exceptions e)
/* This is where an embedded system would call its exception handler */
/* This code runs a print out routine */
{
	printf( "\nE X C E P T I O N chip %d: %s\n",n,exceptionStrings[e] );
	printf( " Terminating the program\n");
	exit();
}

void init_slic(int n_chip)
{
BYTE i,j;
unsigned short i_temp[5];
if (0x02==LitDirect(n_chip,8))
	{
	if (0==LitDirect(n_chip,64))
		{
		if (0x33==LitDirect(n_chip,11))
			{
			setState(n_chip,INITIALIZING); /* This will have more effect in future release*/
			EcritDirect(n_chip,8,0); // Clear out Digital Loopback
			EcritDirect(n_chip,108,0x82); // Revision C and above enhancement
			EcritDirect(n_chip,67,0x17);
			EcritDirect(n_chip,66,1);
			EcritDirect(n_chip,71,0);	// Ilim=20mA
			EcritDirect(n_chip,73,2); // Vcm=3V -> 2
			for(i=0;i<4;i++)
				{
				j=i+35;
				i_temp[i]=LitIndirectReg(n_chip,j);
				EcritIndirectReg(n_chip,j,0x8000);
				}
			EcritDirect(n_chip,INTRPT_MASK3, 0x00); 
			EcritDirect(n_chip,INTRPT_MASK2, 0x00);
			EcritDirect(n_chip,INTRPT_MASK1, 0x00);  
			PowerUp(n_chip);
			PowerLeak(n_chip);
			PowerUp(n_chip);
			EcritDirect(n_chip,97,0x1E);
			EcritDirect(n_chip,96,0x47);
			calibrate(n_chip);
			EcritDirect(n_chip,23,4);
			EcritDirect(n_chip,97,1);
			EcritDirect(n_chip,96,0x40);
			printf("Slic %d calibration ...\n",n_chip);
			do
				{
				sleep(1000);
				i=LitDirect(n_chip,96);
				j=LitDirect(n_chip,97);
				//printf("96=%x, 97=%x\n",i,j);
				}
				while(i!=0);
			/*for(i=98;i<=107;i++)
				{
				j=LitDirect(n_chip,i);
				printf("(%d)=%x\n",i,j);
				}*/
			for(i=0;i<4;i++)
				{
				j=i+35;
				EcritIndirectReg(n_chip,j,i_temp[i]);
				}
			for(i=19;i<=23;i++)
				EcritDirect(n_chip,i,0xFF);
			EcritDirect(n_chip,2,0);
			EcritDirect(n_chip,3,0);
			EcritDirect(n_chip,4,0);
			EcritDirect(n_chip,5,0);
			EcritDirect(n_chip,1,0x00); // PCM disable, A-loi 8 bit 
			EcritDirect(n_chip,8,0);
			EcritDirect(n_chip,9,0x05);
			EcritDirect(n_chip,10,0x2a);
			EcritDirect(n_chip,11,0x66);
			EcritDirect(n_chip,70,0x0a);
			EcritDirect(n_chip,72,0x08);  // Voc=24V
			EcritDirect(n_chip,INTRPT_MASK3, 0xff); // Register 23
			EcritDirect(n_chip,INTRPT_STATUS3, 0xff); // Register 20
			EcritDirect(n_chip,INTRPT_MASK2, 0xff); // Register 22
			EcritDirect(n_chip,INTRPT_STATUS2, 0xff); // Register 19
			EcritDirect(n_chip,INTRPT_MASK1, 0xff); // Register 21
			EcritDirect(n_chip,INTRPT_STATUS1,0xff); // Register 18
			}
			else
			exception(n_chip,PROSLICiNSANE);
		}
		else
		exception(n_chip,PROSLICiNSANE);
	}
	else
	exception(n_chip,PROSLICiNSANE);
}


void disableOscillateur(int n)
{
BYTE i;
//printf("disable oscillateur %d\n",n);
for(i=32;i<=45;i++)
	if (i!=34)
		EcritDirect(n,i,0);
}

void goActive(int n)
{
int tempo;
printf("Active slic %d\n",n);
EcritDirect(n,64,1);
sleep(100);
}

void cadenceRingPhone(int n,ringStruct ringRegs) 
{ 
	// Enables ringing mode on ProSlic for standard North American ring
	//	RING_ON__LO	48
	//	RING_ON_HI	49
	//	RING_OFF_HI	51
	//	RING_OFF_LO	50
	printf ("on= %d ms off =%d ms\n", ringRegs.onTime.Word/8, ringRegs.offTime.Word/8);
	EcritDirect(n, RING_ON__LO,  ringRegs.onTime.Byte.Low); // lo reg 48
	EcritDirect(n, RING_ON_HI,   ringRegs.onTime.Byte.Hi); // hi reg 49
	// Inactive Timer
	EcritDirect(n, RING_OFF_LO, ringRegs.offTime.Byte.Low); // low reg 50
	EcritDirect(n, RING_OFF_HI, ringRegs.offTime.Byte.Hi); // hi reg 51
	// Enable timers for ringing oscillator
	EcritDirect(n, 34, 0x18);
}

void StandardRing(int n)
{

EcritDirect(n,48,0x80);
EcritDirect(n,49,0x3E);
EcritDirect(n,50,0x00);
EcritDirect(n,51,0x7D);
EcritDirect(n,34,0x18);
}

void genTone(int n,tone_struct tone)
{
unsigned char osc1_ontimer_enable=0, osc1_offtimer_enable=0,osc2_ontimer_enable=0,osc2_offtimer_enable=0;
	int enable_osc2=0;
disableOscillateur(n);
if (tone.osc1.coeff == 0 || tone.osc1.x == 0) {
		// Error!
		printf("You passed me a invalid struct!\n");
		return;
	}
// Setup osc 1
	EcritIndirectReg(n, OSC1_COEF, tone.osc1.coeff);
	EcritIndirectReg(n, OSC1X, tone.osc1.x);
	EcritIndirectReg(n, OSC1Y, tone.osc1.y);

if (tone.osc1.on_hi_byte != 0) 
	{
		EcritDirect(n, OSC1_ON__LO, tone.osc1.on_low_byte);
		EcritDirect(n, OSC1_ON_HI, tone.osc1.on_hi_byte);
		osc1_ontimer_enable = 0x10;
	}
if (tone.osc1.off_hi_byte != 0) 
	{
		EcritDirect(n, OSC1_OFF_LO, tone.osc1.off_low_byte);
		EcritDirect(n, OSC1_OFF_HI, tone.osc1.off_hi_byte);
		osc1_offtimer_enable = 0x08;
	}
if (tone.osc2.coeff != 0) 
	{
		// Setup OSC 2
		EcritIndirectReg(n, OSC2_COEF, tone.osc2.coeff);
		EcritIndirectReg(n, OSC2X, tone.osc2.x);
		EcritIndirectReg(n, OSC2Y, tone.osc2.y);
		
		// Active Timer
		if (tone.osc1.on_hi_byte != 0) {
			EcritDirect(n, OSC2_ON__LO, tone.osc2.on_low_byte);
			EcritDirect(n, OSC2_ON_HI, tone.osc2.on_hi_byte);
			osc2_ontimer_enable = 0x10;
		}
		// Inactive Timer
		if (tone.osc1.off_hi_byte != 0) {
			EcritDirect(n, OSC2_OFF_LO, tone.osc2.off_low_byte);
			EcritDirect(n, OSC2_OFF_HI, tone.osc2.off_hi_byte);
			osc2_offtimer_enable = 0x08;
		}
		enable_osc2 = 1;
	}
EcritDirect(n, OSC1, (unsigned char)(0x06 | osc1_ontimer_enable | osc1_offtimer_enable));
if (enable_osc2)
	EcritDirect(n, OSC2, (unsigned char)(0x06 | osc2_ontimer_enable | osc2_offtimer_enable));
}

void Ring(int n,BYTE mode)
{
if (mode==0)
	{
	goActive(n);
	//EcritDirect(n,64,0x00);
	}
	else
	EcritDirect(n,64,0x44);
}

unsigned int LitIrq(int n)
{
registre_irq r_irq;
r_irq.status_irq=0;
r_irq.registre[3]=LitDirect(n,18);
r_irq.registre[2]=LitDirect(n,19);
r_irq.registre[1]=LitDirect(n,20);
EcritDirect(n,18,r_irq.registre[3]);
EcritDirect(n,19,r_irq.registre[2]);
EcritDirect(n,20,r_irq.registre[1]);
return r_irq.status_irq;
}



void loopAction(int n_chip)
{
BYTE r68;
int a_mcm;
r68=LitDirect(n_chip,68);
gotoxy(1,5);
printf("loop action, chip =%d, r68=%x \n",n_chip,r68);
if ( (chip[n_chip].state != MAKEoFFHOOK) && (r68 & 0x3) )
	{
		 if (chip[n_chip].version <=2 )  // if REVISION B  set to active.
	{
	
	goActive(chip[n_chip].num_chip);  // Rev B fix not needed 
    
	}
	if (chip[n_chip].previousState != RINGING)
		setState(n_chip,MAKEoFFHOOK);
		else
		setState(n_chip,MAKEcONNECT);
		chip[n_chip].Off_Hook_time = clock();
		//printf("off Hook time=%d\n",chip->Off_Hook_time);
		return;		
	}
/**if ((chip->state != ONHOOK) && (r68& 0x3)==0 )
	{		

		setState(n_chip,ONHOOK);
		chip[n_chip].On_Hook_time = clock();
	
	if ((chip[n_chip].On_Hook_time - chip[n_chip].Off_Hook_time  ) < 2000 )
		{
		setState(chip,CALLBACK);
		return;
		}
	}*/
printf("On HOOK\n");
EnableVt(n_chip,0);
a_mcm=LitVt(n_chip);
if (a_mcm!=0)
	{
	E_Mcm(a_mcm,1);
	SetEtatMcm(a_mcm,0);
	EcritVt(n_chip,0);
	}
if (chip[n_chip].vt_distant!=0)
	{
	int c_distant;
	c_distant=RechecheChipDistant(chip[n_chip].vt_distant);
	chip[c_distant].ringCount=6;
	DeconnectPCM(chip[n_chip].vt_distant);
	E_Mcm(chip[n_chip].vt_distant,1);
	SetEtatMcm(chip[n_chip].vt_distant,0);
	chip[n_chip].vt_distant=0;
	}
setState(n_chip,ONHOOK); 	
chip[n_chip].On_Hook_time = clock();
disableOscillateur(n_chip);
}

void callerid(int n_chip)
{

}

void dtmfAction(int n_chip)
{
void (*funct)();
	unsigned char digit;
	char asciiChar;
	setState(n_chip,DIGITDECODING);
	asciiChar=LitDirect(chip[n_chip].num_chip,24);
	//printf("reg(24)=%x\n",asciiChar);
	digit = asciiChar & 0x0f;
	
	//asciiChar= '0' + digit;
	switch (digit){
	case 0xA :
			asciiChar = '0';
			break;
	case 0xB:
			asciiChar = '*';
			break;
	case 0xC:
			asciiChar = '#';
			break;

	default:
		asciiChar= '0' + digit;
		break;
	}
		 if (chip[n_chip].digit_count < 20)
		 {
			chip[n_chip].DTMF_digits[chip[n_chip].digit_count] = asciiChar; 
			chip[n_chip].digit_count++;
			chip[n_chip].DTMF_digits[chip[n_chip].digit_count]= 0;
		
		gotoxy(1,15+n_chip);	
		printf("Value= 0x%01x  String collected \"%s\" \n", digit, &chip[n_chip].DTMF_digits );	
		if (chip[n_chip].digit_count==4)
			{
			printf("Recherche Poste %s...\n",chip[n_chip].DTMF_digits);
			if (1==GestionAbonne(n_chip))
				{
				disableOscillateur(n_chip);
				setState(n_chip,MAKErINGbACK);
				}
				else
				{
				disableOscillateur(n_chip);
				setState(n_chip,MAKEcONGESTION);
				}
			}

	/*	funct =findNumber();
		if (funct) 
			funct();*/
		 }

}

void stateMachine(int n_chip)
{
int a_mcm;
int c_distant;
unsigned long temps;
//printf("state=%d\n",chip->state);
switch(chip[n_chip].state)
	{
	case STATEcHANGE:
		 chip[n_chip].state=chip[n_chip].newState;
		  break;
	case CALLBACK :
		disableOscillateur(n_chip);	
		StandardRing(chip[n_chip].num_chip);
		
		Ring(n_chip,1);
		chip[n_chip].state = FIRSTrING;
		break; 
	case CALLBACKpROGRAMMED:
		disableOscillateur(n_chip);
		Ring(n_chip,1);
		chip[n_chip].state = PROGRAMMEDrING;
		break;
	case MAKEoFFHOOK: // Make dialtone 
	      a_mcm=RechercheMcm();
		if (a_mcm==0)
			{
			disableOscillateur(chip[n_chip].num_chip);
			setState(n_chip,MAKEcONGESTION);
			}
			else
			{
			printf("chip%d, vt=%d\n",chip[n_chip].num_chip,a_mcm);
			SetEtatMcm(a_mcm,1);
			EcritVt(n_chip,a_mcm);
			EnableVt(n_chip,1);
			genTone(chip[n_chip].num_chip, DialTone);
			setState(n_chip,DIALtONE);
			}
		chip[n_chip].digit_count=0;
		break;
	case MAKEcONNECT:
		 printf("Connection...\n");
		 Ring(n_chip,0); //stopRinging(chip);
		 chip[n_chip].ringCount=0;
		 c_distant=RechecheChipDistant(chip[n_chip].vt_distant);
		 disableOscillateur(c_distant);
		 chip[c_distant].ringCount=0;
		 goActive(c_distant);
		 setState(n_chip,OFFHOOK);
		 setState(c_distant,OFFHOOK);
		 connectRcx(n_chip,1);
		 
		break;
	case CONNECT :
			break;
	case DIALtONE:
		temps=clock()-chip[n_chip].Off_Hook_time;
		if (temps>20000)
			{
			disableOscillateur(chip[n_chip].num_chip);
			setState(n_chip,MAKEcONGESTION);
			}
		break;
	case LOOPtRANSITION:		
			if (chip[n_chip].version <= 2)
				EcritDirect(n_chip,69,10);   // Loop Debounce Register  = initial value
				gotoxy(1,30+n_chip);
				printf("chip %d,transition, %s\n",n_chip,str_etat[chip[n_chip].previousState]);
				switch (chip[n_chip].previousState){
												
						//case RINGING:
						case CALLERiD:
						case FIRSTrING:
							printf("stop ring\n");
							Ring(n_chip,0); //stopRinging(chip);
							disableOscillateur(n_chip);
							chip[n_chip].ringCount=0;
							//setState(n_chip,MAKEcONNECT);
				 			break;
						case DEFEREDcALLBACKpROGRAMMED:
							setState (n_chip,CALLBACKpROGRAMMED);
							break;

						case PRENEON:
						while (LitDirect(n_chip,82) < (48/1.5 - 3));
							EcritDirect(n_chip,72,0x10);//  High Neon
							setState(n_chip,NEON);
						break;
						case RINGING :
							Ring(n_chip,0); //stopRinging(chip);
							disableOscillateur(n_chip);
							chip[n_chip].ringCount=0;
						default:
							loopAction(n_chip);
				}
		break;
	case DTMFtRANISTION:
			switch (chip[n_chip].previousState){
						case OFFHOOK:
						case BUSY:
						case RINGbACK:
						break;
						case DIALtONE:
							disableOscillateur(n_chip);
							dtmfAction(n_chip);
							break;
						case DIGITDECODING:
							dtmfAction(n_chip);
							break;
			}
		break;
	case CALLERiD:
		//callerid(n_chip);
		disableOscillateur(n_chip);	
		StandardRing(chip[n_chip].num_chip);
		Ring(n_chip,1);
		//chip[n_chip].state = FIRSTrING;
		setState(n_chip,RINGING);
		break;
	case RINGING:
		if (chip[n_chip].ringCount>5)
			{
			Ring(n_chip,0); //stopRinging(chip);
			chip[n_chip].ringCount=0;
			setState(n_chip,ONHOOK);
			}
		break;
	case MAKEbUSY:
		genTone(n_chip, BusySignal);
		setState(n_chip,BUSY);
		chip[n_chip].digit_count=0;
		break;
	case MAKErINGbACK:
		genTone(n_chip, RingbackNormal);
		setState(n_chip,RINGbACK);
		chip[n_chip].digit_count=0;
		break;
	case MAKErEORDER:
		genTone(n_chip, ReorderTone);
		setState(n_chip,REORDER);
		chip[n_chip].digit_count=0;
		break;
	case MAKEcONGESTION:
		genTone(n_chip, CongestionTone);
		setState(n_chip,CONGESTION);
		chip[n_chip].digit_count=0;
		break;
	}
}

void nextCadence(n_chip) 
{
int x = chip[n_chip].ringCadenceCordinates.nextCadenceEntryIndex;
int y =chip[n_chip].ringCadenceCordinates.ringType;
/* Start current coordinate in the table */

cadenceRingPhone(n_chip,ringCadenceTables[y][x].ringRegs);

/* change coordinate */
chip[n_chip].ringCadenceCordinates.nextCadenceEntryIndex= ringCadenceTables[y][x].next;

}

void gestion_isr(n_chip)
{
int i,mask;
int isr;
 enum              // Declare enum type Days
{
OSC1_T1=0,  
OSC1_T2=1,
OSC2_T1=2,
OSC2_T2=3,
RING_T1=4,
RING_T2=5,
PULSE_T1=6,
PULSE_T2=7,
RING_TRIP=8,
LOOP__STAT=9,
PQ1=10,
PQ2=11,
PQ3=12,
PQ4=13,
PQ5=14,
PQ6=15,
DTMF=16, /* DTMF detected */
INDIRECT=17, /* Indirect Reg Access ready */
CAL_CM_BAL=18, /* Common Mode Calibration Error */
} interruptCause;                // Variable today has type Days

static char * icause[]={
"Osc1 Inactive           ",  
"Osc1 Active             ",  
"Osc2 Inactive           ",  
"Osc2 Active             ",  
"Ring Inactive           ", 
"Ring Active             " ,
"Pulse Metering Inactive ",
"Pulse Metering Active   ",
"Ring Trip               ",
"Loop Status Change      ",
"Pwr Alarm Q1            ",
"Pwr Alarm Q2            ",
"Pwr Alarm Q3            ",
"Pwr Alarm Q4            ",
"Pwr Alarm Q5            ",
"Pwr Alarm Q6            ",
"DTMF Decode             ", /* DTMF detected */
"Indirect Access Complete", /* Indirect Reg Access ready */
"Common mode balance fault",
 };
mask=1;
isr=chip[n_chip].interrupt;
for(interruptCause=OSC1_T1;interruptCause<=CAL_CM_BAL;interruptCause++)
	{
	//printf("mask =%x, i_cause=%d\n",mask,interruptCause);
	if (chip[n_chip].interrupt&mask)
		{
		chip[n_chip].interrupt&=~mask;
		gotoxy(1,25+n_chip);
		printf("%s\n",icause[interruptCause]);
		switch(interruptCause)
			{
			case OSC1_T1 :
			case OSC1_T2 :
			case OSC2_T1 :
			case OSC2_T2 :
					  break;
			case RING_T1 : 
				chip[n_chip].ringCount++;
				if (chip[n_chip].state==FIRSTrING)
					{ 
					chip[n_chip].ringCount=1;
					if (chip[n_chip].version >2)
					setState(n_chip,CALLERiD);
					else
					setState(n_chip,RINGING);
					}
				break;
			case RING_T2 :
				if (chip[n_chip].state==PROGRAMMEDrING)
					{
					nextCadence(n_chip);
					}
					  break;
			case PULSE_T1 :
			case PULSE_T2 :
					  break;
			case RING_TRIP :
			if (chip[n_chip].version <=2 )  // if REVISION B  set to active.
				{
				goActive(n_chip); // Rev B fix not needed 
				}
					  break;
			case LOOP__STAT:
				if ((LitDirect(n_chip,80) < 2) || LitDirect(n_chip,81) < 2) 
					exception(n_chip,TIPoRrINGgROUNDsHORT); /* Check for grounded Tip or Ring Leads*/
				setState(n_chip,LOOPtRANSITION);
					  break;
			case PQ1:
			case PQ2:
			case PQ3:
			case PQ4:
			case PQ5:
			case PQ6:
		{	static unsigned long lastEventNumber =1;
		if (lastEventNumber != chip[n_chip].eventNumber)  /*  We allow only one alarm per alarm event */
		{
			int i = interruptCause - PQ1;
		lastEventNumber = chip[n_chip].eventNumber;
		PowerLeak(n_chip);
		PowerUp(n_chip);
		printf( "  %d time\n",chip[n_chip].qLog[i]);
		if (chip[n_chip].qLog[i]++>2)    
			exception(n_chip,POWERaLARMQ1+i);
		if(chip[n_chip].qLog[i] >1) printf( "s");
		EcritDirect(n_chip,19,0xFC); //Clear Alarm bits
		goActive(n_chip);
		setState(n_chip,ONHOOK);
		}			 
		}
					break;
			case DTMF: setState(n_chip,DTMFtRANISTION);
					break;
			case INDIRECT:
					break;
			}
		}
	mask<<=1;
	}
}

void InitChipStruct(int n_chip)
{
BYTE i;
chip[n_chip].num_chip=n_chip;
i=LitDirect(n_chip,0);
chip[n_chip].version=0x0F&i;
chip[n_chip].type=(0x30&i) >> 4;
chip[n_chip].interrupt = 0;
chip[n_chip].digit_count = 0;
chip[n_chip].ringCount=0;
chip[n_chip].eventEnable =1;
chip[n_chip].num_vt.Word=0;
chip[n_chip].vt_distant=0;
printf("chip=%d, type=%d, version=%d\n",chip[n_chip].num_chip,chip[n_chip].type,chip[n_chip].version);
}

void GestionChip(int n_chip)
{
//printf("chip =%d, event =%d\n",chip->num_chip,chip->eventEnable);
if (chip[n_chip].eventEnable) 
	{
	chip[n_chip].interrupt=LitIrq(n_chip);
	if (chip[n_chip].interrupt)
		{
		//printf("isr=%x\n",chip[n_chip].interrupt);
		gestion_isr(n_chip);   // isr = interrrupt service routine
		}
	}
	stateMachine(n_chip);
}

void EcritVt(int n_chip,unsigned short vt)
{
//unsigned short tmp;
//tmp=8*vt+1;
chip[n_chip].num_vt.Word=8*vt;
//EcritDirect(chip->num_chip,1,0x00); // PCM enable, A-loi 8 bit
gotoxy(1,8);
printf("chip %d, vt=%d, registre=%d\n",chip[n_chip].num_chip,vt,chip[n_chip].num_vt.Word);
//printf("hi=%x lo=%x\n",chip->num_vt.Byte.Hi,chip->num_vt.Byte.Low);
EcritDirect(n_chip,3,chip[n_chip].num_vt.Byte.Hi);
EcritDirect(n_chip,2,chip[n_chip].num_vt.Byte.Low);
EcritDirect(n_chip,5,chip[n_chip].num_vt.Byte.Hi);
EcritDirect(n_chip,4,chip[n_chip].num_vt.Byte.Low);
//EcritDirect(chip->num_chip,1,0x20); // PCM enable, A-loi 8 bit
}

void EnableVt(int n_chip,int n)
{
if (n==0)
	EcritDirect(chip[n_chip].num_chip,1,0x00); // disable
	else
	EcritDirect(chip[n_chip].num_chip,1,0x20); // enable
}

int LitVt(int n_chip)
{
int num;
num=chip[n_chip].num_vt.Word;
num/=8;
return num;
}

void AfficheChip(int num)
{
gotoxy(5,20+num);
printf("chip %d, p=%s, c=%s, n=%s vt_d=%d    \n",num,str_etat[chip[num].previousState],
								str_etat[chip[num].state],str_etat[chip[num].newState],
								chip[num].vt_distant);
}

int RechecheChipDistant(int distant)
{
int i;
int dist=0;
for(i=0;i<4;i++)
	{
	if (distant==LitVt(i))
		{
		dist=i;
		break;
		}
	}
return dist;
}