#include <stdio.h>
#include <string.h>
#include "structures_donnees.h"
#include "Cpu_reg.h"
#include "etd500.h"
#include "rs232.h"

Rcx rcx;

void E_Mcm(char adr,char valeur)
{
char v_status;
ETD500_A_MCM=(adr-1)&0x1F;
ETD500_D_MCM=(valeur+1)&0x1F;
ETD500_ctrl=1;
do
	{
	v_status=ETD500_status;
//	if (v_status!=5)
//		printf("v_status =%x\n",v_status);
	}
while(v_status!=5);
ETD500_ctrl=0;
while(ETD500_status!=0);
//	printf("E_Mcm, status=%x\n",ETD500_status);
//ETD500_A_MCM=0;
//ETD500_D_MCM=0;
}

char L_Mcm(char adr)
{
char valeur=0x00;
ETD500_A_MCM=adr;
ETD500_ctrl=2;
while(!(ETD500_status&0x02));
valeur=ETD500_D_MCM;
ETD500_ctrl=0;
return valeur;
}

void init_rcx()
{
char i;
V_CODEC=0;
ETD500_ctrl=0;
ETD500_SE=0xFF;
ETD500_TX=0x00;
for(i=0;i<32;i++)
	{
//	printf("adr=%d\n",i);
	E_Mcm(i,0);
	rcx.mcm[i].valeur=0;
	}
rcx.mcm[0].s_mcm.etat=3; 
rcx.mcm[1].s_mcm.etat=3; 
//rcx.mcm[3].s_mcm.etat=3; 
ETD500_A_MCM=0;
}

int InitRcx(char *param)
{
int i;
rcx.num_autocom=0;
init_rcx();
//rcx.mode=MANUEL;
return 1;
}

char LitEtatMcm(char adr)
{
char etat=0;
if (adr>=0&&adr<32)
	etat=rcx.mcm[adr].s_mcm.etat;
return etat;
}

char RechercheMcm()
{
char result=0;
int i;
for(i=0;i<32;i++)
	{
	//printf("(%d)=%x\n",i,rcx.mcm[i].valeur);
	if (0==rcx.mcm[i].s_mcm.etat)
		{
		result=i;
		break;
		}
	}
return result;
}

void Affiche_Mcm()
{
int i;
gotoxy(1,10);
for(i=0;i<32;i++)
	printf("%x ",rcx.mcm[i].valeur);
printf("\n");
}

void SetEtatMcm(char adr,char etat)
{
if (adr>=0&&adr<32)
	rcx.mcm[adr].s_mcm.etat=etat;
//printf("(%d)=%x\n",adr,rcx.mcm[adr].valeur);
}


int EcritMcm(char *param)
{
int adr=0,valeur=0,result;
result=sscanf(param,"%x %x",&adr,&valeur);
if (result==2)
	{	
	if (adr>=0&&adr<32&&valeur>=0&&valeur<32)
		{
		rcx.mcm[adr&0x1F].s_mcm.valeur=valeur&0x1F;	
		E_Mcm(adr,valeur);
		return 1;
		}
		else
		return 0;
	}
	else
	return 0;
}

int LitMcm(char *param)
{
int result=0;
char travail[128];
if (strlen(param)==0)
	{
	int i;
	char *p_str;
	strcpy(travail,"MCM ");
	p_str=travail;
	p_str+=4;
	for(i=0;i<32;i++)
		{
		strprintf(p_str,"%2X",rcx.mcm[i]);
		p_str+=2;
		}
	E_Missive(travail);
	result=1;
	}
	else
	{
	int adr;
	result=sscanf(param,"%x",&adr);
	if (result==1)
		{
		if (adr>=0&&adr<32)
			{
			strprintf(travail,"LMCM %2X%2X",adr,rcx.mcm[adr]);
			E_Missive(travail);
			}
			else
			result=0;
		}
		else	
		result=0;
	}
return result;
}
