

#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Structures_donnees.h"
#include "rs232.h"

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <ctype.h>

#define TAILLE_BUFFER	128

char buffer_rx[TAILLE_BUFFER+1];
int e_rang_rx;
int l_rang_rx;
int nb_caract;


int rang_trame;

E_Trame etat_trame;

char ctype_trame;
char str_commande[20];
char str_param[20];
char str_long[5];

void isr_rs232();

void Init_rs232()
{
etat_trame=ATTENTE;
etat_rs232.valeur=0x0000;
e_rang_rx=0;
l_rang_rx=0;
rang_trame=0;
nb_caract=0;
memset(buffer_rx,' ',TAILLE_BUFFER);
str_commande[0]=0;
str_param[0]=0;
str_long[0]=0;
SCCR0 = 9;
SetVect(98,&isr_rs232);	     	// mise en place du vecteur d'interruption 
QSMCR=0x0005;		// Positionner le IARB -> Priorit 
QILR=0x0562;		// 0x62=98         QILR=ILSCI/QIVR
SCCR1= 0x002C;		// Pour valider l'mission et la rceptionn srie et les interruptions en rception
}

void Stop_rs232()
{
SCCR1= 0x000C;
QSMCR=0x0000;		// Positionner le IARB -> Priorit 
QILR=0x0000;	//0x62=98         QILR=ILSCI/QIVR
RestoreVect(98);
}

int TestErreur()
{
if (erreur_trame==1||erreur_c==1)
	return 1;
	else
	return 0;
}

E_Trame LitEtat_Trame()
{
return etat_trame;
}

void RazErreur()
{
if (etat_trame==ERREUR)
	{
	etat_trame=ATTENTE;
	E_Missive("E1");
	}
	else
	if (erreur_trame==1)
		{
		erreur_trame=0;
		E_Missive("E0");
		}
		else
		if (erreur_c==1)
			{
			erreur_c=0;
			E_Missive("E2");
			}
		
}

int TraiteRecept(char *type_r,char *comm,char *p_comm)
{
char caract;
int result=0;
while (nb_caract>0)
{
caract=buffer_rx[l_rang_rx++];
l_rang_rx&=(TAILLE_BUFFER-1);
nb_caract--;
switch(caract)
	{
	case '?' :
	case '!' :  rang_trame=0;
		      erreur_trame=0;
			ctype_trame=caract;
			etat_trame=TYPE_T;
			str_long[0]=0;
			str_commande[0]=0;
			str_param[0]=0;
			//OutRs232(ctype_trame);
			break;
	default :   if (etat_trame==TYPE_T)
				{
				if (isxdigit(caract))
					{
					str_long[rang_trame++]=caract;
					str_long[rang_trame]=0;
					if (rang_trame==2)
						{
						//OutRs232('L');
						etat_trame=L_TRAME;
						rang_trame=0;
						}
					}
					else
					etat_trame=ERREUR;
				}
				else
				if (etat_trame==L_TRAME)
					{
					if (caract==' ')
						{
						//printf("c=%s\n",str_commande);
						etat_trame=COMMANDE;
						rang_trame=0;
						}
						else
						{
						str_commande[rang_trame++]=caract;
						str_commande[rang_trame]=0;
						}
					}
					else
					if (etat_trame==COMMANDE)
						{
						str_param[rang_trame++]=caract;
						str_param[rang_trame]=0;
						}
			//trame_rx[rang_trame++]=caract;	
			break;
	case '\r' : if(etat_trame==COMMANDE||etat_trame==L_TRAME)
				etat_trame=FIN_TRAME;
				else
				etat_trame=ERREUR;			
			break;
	case '\n' : if (erreur_trame==0&&etat_trame==FIN_TRAME)
				{
				*type_r=ctype_trame;
				if (strlen(str_commande)>0)
					{
					strcpy(comm,str_commande);
					strcpy(p_comm,str_param);
					etat_trame=ATTENTE;
					result=1;
					}
					else
					{
					erreur_c=1;
					}		
				} 
				else
				printf("erreur\n");
			break;
	}
}
return result;
}

void E_Missive(char *texte)
{
char travail[200];
int len,i;
len=strlen(texte)+4;
strprintf(travail,"!%2X%s\r\n",len,texte);
len++;
for(i=0;i<len;i++)
	OutRs232(travail[i]);
}

void isr_rs232()
{
char register status;
char register caract;
status=SCSR;
if (status&RDRF)
	{
	caract=(char)SCDR;
	buffer_rx[e_rang_rx++]=caract;
	e_rang_rx&=(TAILLE_BUFFER-1);
	nb_caract++;
	}
if (status&0x0008)
	{
	caract=(char)SCDR;
	erreur_or=1;
	erreur_trame=1;
	}
}

int strprintf(char *str,char *format,...)
{
const char table_hexa[] ={"0123456789ABCDEF"};
const int *arg;
int digit;
int rang;
int fin;
int valeur;
int i=0,j=0,k;
char *p_str;
va_start(arg,format);
while(format[i]!=0) 
	{
	if (format[i]=='%')
		{
		digit=8;
		fin=0;
		while(fin==0)
		{
		i++;
		if (isdigit(format[i]))
			digit=format[i]-'0';
			else
			switch(format[i])
			{
			case '%' : fin=1;
					str[j++]=format[i];
					i++;
					break;
			case 'c' : valeur=va_arg(arg,int);
					i++;
					str[j++]=(char)(valeur&0xFF);
					fin=1;
					break;
			case 's' : p_str=va_arg(arg,char *);
					for(k=0;p_str[k]!=0;k++)
						str[j++]=p_str[k];
					i++;
					fin=1;
					break;
			case 'x' :
			case 'X' : valeur=va_arg(arg,int);
					for(k=digit-1;k>=0;k--)
					{
					rang=(valeur>>(4*k))&0x0F;
					str[j]=table_hexa[rang];
					j++;
					}
					fin=1;
					i++;
					break;
			}
		}
		}
		else
		{
		str[j]=format[i];
		j++;
		i++;
		}
	}
str[j]=0;
va_end(arg);
}

