#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Structures_donnees.h"
#include "rs232.h"
#include "s_com.h"

#include <stdio.h>
#include <string.h>

#include "slic.h"

chipStruct chip[4];

indirectRegister  indirectRegisters[] =
{
/* Reg#			Label		Initial Value  */

{	0,	0x55C2	},
{	1,	0x51E6	},
{	2,	0x4B85	},
{	3,	0x4937	},
{	4,	0x3333	},
{	5,	0x0202	},
{	6,	0x0202	},
{	7,	0x0198	},
{	8,	0x0198	},
{	9,	0x0611	},
{	10,	0x0202	},
{	11,	0x00E5	},
{	12,	0x0A1C	},
{	13,	0x7b30	},
{	14,	0x0063	},
{	15,	0x0000	},
{	16,	0x7870	},
{	17,	0x007d	},
{	18,	0x0000	},
{	19,	0x0000	},
{	20,	0x799A	},
{	21,	0x019A	},
{	22,	0x0000	},
{	23,	0x2000	},
{	24,	0x2000	},
{	25,	0x0000	},
{	26,	0x4000	},
{	27,	0x4000	},
{	28,	0x1000	},
{	29,	0x3600	},
{	30,	0x1000	},
{	31,	0x0200	},
{	32,	0x7c0   },
{	33,	0x2600	},
{	34,	0x1B80	},
{	35,	0x8000	},
{	36,	0x06A8	},
{	37,	0x08c	},
{	38,	0x0100	},
{	39,   0x0010	},
{	40,	0x0200	},
{	41,	0x0C00	},
{	43,	0x1000	},
{	99,	0x00DA	},
{	100,	0x6B60	},
{	101,	0x0074	},
{	102,	0x79C0	},
{	103,	0X1120	},
{	104,	0x3BE0	},
{	97,				0},
{0,0},
};

void InitDaisy()
{
BYTE tmp[]={0x0,0xC0};
EcritCmd(2,0);
EcritTx(2,tmp);
Envoi();
}

void EcritDirect(char n,char add,char data)
{
BYTE buffer[3];
buffer[0]=1<<n;
buffer[1]=add&0x7F;
buffer[2]=data;
//printf("Ecr,chip=%d, add=%x, data=%x\n",n,add,data);
EcritCmd(3,0);
EcritTx(3,buffer);
Envoi();
}

BYTE LitDirect(char n,char add)
{
int tempo;
BYTE v;
BYTE buffer[2];
buffer[0]=1<<n;
buffer[1]=0x80+(add&0x7F);
EcritCmd(3,0);
EcritTx(2,buffer);
Envoi();
//affiche_buffer();
for(tempo=0;tempo<100;tempo++);
v=*(SPI_RXD+2);
//printf("LECT, chip=%d, add=%x,data=%x\n",n,add,v);
return v;
}

void WaitForIndirectReg(BYTE n)
{
BYTE status;
do
	{ 
	status=LitDirect(n,I_STATUS);
//	printf("I_status=%x\n",status);
	}
while(status);
}

unsigned short LitIndirectReg(int n,int add)
{
unsigned short v,v1;
WaitForIndirectReg(n);
EcritDirect(n,IAA,add);
WaitForIndirectReg(n);
v1=LitDirect(n,IDA_HI);
v=v1<<8;
v|=LitDirect(n,IDA_LO);
//printf("v1=%x ,v=%x\n",v1,v);
return v;
}

void EcritIndirectReg(int n,int add, unsigned short v)
{
unsigned short v1;
v1=v>>8;
//printf(" e, v1=%x, v=%x\n",v1,v&0xFF);
WaitForIndirectReg(n);
EcritDirect(n,IDA_LO,(BYTE)(v&0xFF));
EcritDirect(n,IDA_HI,(BYTE)(v1&0xFF));
EcritDirect(n,IAA,(BYTE)add);
//WaitForIndirectReg(n);
}

void initializeIndirectRegisters(int n)
{
	unsigned char i=0;
	while (indirectRegisters[i].initial || indirectRegisters[i].address ) {
	EcritIndirectReg(n,indirectRegisters[i].address,indirectRegisters[i].initial);
	i++;
	}
}

void InitChipStruct(int n)
{
BYTE i;
chip->num_chip=n;
i=LitDirect(n,0);
chip[n].version=0x0F&i;
chip[n].type=(0x30&i) >> 4;
chip[n].interrupt = 0;
chip[n].digit_count = 0;
chip[n].eventEnable =1;
chip[n].num_vt.Word=9;
printf("chip=%d, type=%d, version=%d\n",chip[n].num_chip,chip[n].type,chip[n].version);
}

void setState(int n,int n_stat)
{
chip[n].previousState=chip[n].state;
chip[n].newState= n_stat;
chip[n].state=STATEcHANGE;
//printf("changing stat =%d\n",chip->newState);
switch (n_stat)
	{
			 case CALLERiD:
				 chip[n].eventEnable=0;
				 break;
			 case RINGING:
				 chip[n].eventEnable=1;
				 break;
	}
}

unsigned char PowerUp(int n)
{
BYTE vbat,vbath,vbatl,tmp;
float tension;
EcritDirect(n,74,33);		// vtabh = -48V
EcritDirect(n,75,0x18);		// vbatl = -24V
EcritDirect(n,92,183);
EcritDirect(n,93,21);
tmp=LitDirect(n,94);
printf("94=%x\n",tmp);
EcritDirect(n,14,0);
do
	{
	tmp=LitDirect(n,94);
	vbat=LitDirect(n,82);
	tension=(float)vbat;
	tension*=.376;
	printf("power(%d),vbat=%x=%.2f\n",n,vbat,tension);
	sleep(500);
	}
	while(vbat<0x40);  //0x68
EcritDirect(n,93,0x80);
do
   {
   tmp=LitDirect(n,93);
   printf("reg(93)=%x\n",tmp);
   }
   while(tmp&0x80);
return vbat;
}

unsigned char PowerLeak(int n)
{
BYTE vbat;
EcritDirect(n,64,0);
EcritDirect(n,14,0x10);
sleep(1000);
vbat=LitDirect(n,82);
printf("power down=%x\n",vbat);
return vbat;
}

void calibrate(int n)
{
BYTE cal,result;
printf("calibration\n");
//EcritDirect(n,98,0x10);
//EcritDirect(n,99,0x10);
for(cal=0x1F;cal>0;cal--)
	{
	EcritDirect(n,98,cal);
	sleep(40);
	result=LitDirect(n,88);
	if (result==0)
		break;
	}
printf("98=%x, 88=%x\n",cal,result);
for(cal=0x1F;cal>0;cal--)
	{
	EcritDirect(n,99,cal);
	sleep(40);
	result=LitDirect(n,89);
	if (result==0)
		break;
	}
printf("99=%x, 89=%x\n",cal,result);
}

int init_slic(int n) //chipStruct *chip)
{
BYTE i,j;
//int n;
unsigned short i_temp[5];
//n=chip->num_chip;
if (0x02==LitDirect(n,8))
	{
	if (0==LitDirect(n,64))
		{
		if (0x33==LitDirect(n,11))
			{
			setState(n,INITIALIZING); /* This will have more effect in future release*/
			EcritDirect(n,8,0); // Clear out Digital Loopback
			EcritDirect(n,108,0x82); // Revision C and above enhancement
			EcritDirect(n,67,0x17);
			EcritDirect(n,66,1);
			EcritDirect(n,71,0);	// Ilim=20mA
			EcritDirect(n,73,2); // Vcm=3V -> 2
			for(i=0;i<4;i++)
				{
				j=i+35;
				i_temp[i]=LitIndirectReg(n,j);
				EcritIndirectReg(n,j,0x8000);
				}
			EcritDirect(n,INTRPT_MASK3, 0x00); 
			EcritDirect(n,INTRPT_MASK2, 0x00);
			EcritDirect(n,INTRPT_MASK1, 0x00);  
			PowerUp(n);
			PowerLeak(n);
			PowerUp(n);
			EcritDirect(n,97,0x1E);
			EcritDirect(n,96,0x47);
			calibrate(n);
			EcritDirect(n,23,4);
			EcritDirect(n,97,1);
			EcritDirect(n,96,0x40);
			printf("Slic %d calibration ...\n",n);
			do
				{
				sleep(1000);
				i=LitDirect(n,96);
				j=LitDirect(n,97);
				//printf("96=%x, 97=%x\n",i,j);
				}
				while(i!=0);
			for(i=98;i<=107;i++)
				{
				j=LitDirect(n,i);
				printf("(%d)=%x\n",i,j);
				}
			for(i=0;i<4;i++)
				{
				j=i+35;
				EcritIndirectReg(n,j,i_temp[i]);
				}
			for(i=19;i<=23;i++)
				EcritDirect(n,i,0xFF);
			EcritDirect(n,2,0);
			EcritDirect(n,3,0);
			EcritDirect(n,4,0);
			EcritDirect(n,5,0);
			EcritDirect(n,1,0x00); // PCM disable, A-loi 8 bit 
			EcritDirect(n,8,0);
			EcritDirect(n,9,0x05);
			EcritDirect(n,10,0x08);
			EcritDirect(n,11,0x03);
			EcritDirect(n,70,0x05);
			EcritDirect(n,72,0x08);  // Voc=24V
			EcritDirect(n,INTRPT_MASK3, 0xff); // Register 23
			EcritDirect(n,INTRPT_STATUS3, 0xff); // Register 20
			EcritDirect(n,INTRPT_MASK2, 0xff); // Register 22
			EcritDirect(n,INTRPT_STATUS2, 0xff); // Register 19
			EcritDirect(n,INTRPT_MASK1, 0xff); // Register 21
			EcritDirect(n,INTRPT_STATUS1,0xff); // Register 18
			return 1;
			}
			else
			return 0;
		}
		else
		return 0;
	}
	else
	return 0;
}

int InitSlic(char *param)
{
int numero,result=0;
result==sscanf(param,"%x",&numero);
if (result==1&&numero>=0&&numero<4)
	{
	initializeIndirectRegisters(numero);
	InitChipStruct(numero);
	init_slic(numero);
	return 1;
	}
	else
	return 0;
}

