// Module gestion SPI pour EID210 

#include "structures_donnees.h"
#include "Cpu_Reg.h"
#include "proslic.h"


#define port_qs	*(BYTE*) 	0xFFFC15
#define pqspar	*(BYTE*)	0xFFFC16
#define ddrqs	*(BYTE*)	0xFFFC17


void InitSpi()
{
port_qs=0x7e;
pqspar=0x7b;
ddrqs=0x7E;
SPCR0=0x8304;
SPCR1=0x1008;
SPSR&=0x00;
SPCR2=0x0100;
SPCR3=0x00;
}

void EcritTx(BYTE n,BYTE *buffer)
{
BYTE i,rang;
for(i=0;i<n;i++)
	{
	rang=i&0x0f;
	*(SPI_TXD+rang)=buffer[i];
	}
}

void EcritCmd(BYTE n,BYTE valeur)
{
BYTE i,rang;
short v;
for(i=0;i<n;i++)
	{
	rang=i&0x0f;
	*(SPI_CMD+rang)=valeur;
	}
v=n-1;
v<<=8;
v&=0x0f00;
SPCR2=v;
//printf("SPCR2=%x, rang=%d\n",SPCR2,rang);
}

void LitTxd(BYTE n,BYTE *buffer)
{
BYTE i,rang;
for(i=0;i<n;i++)
	{
	rang=i&0x0f;
	buffer[i]=*(SPI_RXD+rang);
	}
}

void affiche_spi()
{
printf("SPCR0=%x\nSPCR1=%x\nSPCR2=%x\nSPCR3=%x\nSPSR=%x\n",SPCR0,SPCR1,
									    SPCR2,SPCR3,
										SPSR);
}

void Envoi()
{
int tempo;
BYTE status;
BYTE status_fin;
WORD v;
v=SPCR2&0x0F00;
v>>=8;
status_fin=(BYTE)v;
status_fin|=0x80;
SPCR1|=0x8000;
do
  {
  int tempo;
  status=SPSR;
  //printf("status=%x, fin=%x\n",status,status_fin);
}
while(status!=status_fin);
//sleep(40);
//for(tempo=0;tempo<500;tempo++);
}

void affiche_buffer()
{
int i;
for(i=0;i<5;i++)
	printf("%d, cmd=%x, TX=%x, Rx=%x\n",i,*(SPI_CMD+i),*(SPI_TXD+i),*(SPI_RXD+i));
}

